package com.hxhq.business.service.impl;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hxhq.business.domain.MjyJcgj;
import com.hxhq.business.utils.JctUtil;
import com.hxhq.business.utils.lang.MjyJcnrUtil;
import com.hxhq.common.core.exception.ServiceException;
import com.hxhq.common.core.utils.StringUtils;
import com.hxhq.system.api.domain.SysUser;
import org.springframework.stereotype.Service;
import com.hxhq.business.mapper.MjyJcgjMapper;
import com.hxhq.business.service.IMjyJcgjService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * 麻精药-稽查轨迹Service业务层处理
 *
 * @author hxhq
 * @date 2025-12-18
 */
@Service
public class MjyJcgjServiceImpl extends ServiceImpl<MjyJcgjMapper, MjyJcgj> implements IMjyJcgjService
{

    /**
     * 查询稽查轨迹列表
     * @param mjyJcgj 麻给药
     * @return
     */
    @Override
    public List<MjyJcgj> queryList(MjyJcgj mjyJcgj){
        QueryWrapper<MjyJcgj> queryWrapper = Wrappers.query();
        if(mjyJcgj.getMjyId()==null||mjyJcgj.getMjyId().longValue()<0){
            throw new ServiceException("麻精药id不能为空");
        }
        queryWrapper.eq("mjy_id",mjyJcgj.getMjyId());
        if(mjyJcgj.getJcgjlx()!=null&&mjyJcgj.getJcgjlx().intValue()>0){
            queryWrapper.eq("jcgjlx",mjyJcgj.getJcgjlx());
        }
        if (StringUtils.isNoneBlank(mjyJcgj.getJcmc())) {
            queryWrapper.and(p -> p.like("`jcmc`", mjyJcgj.getJcmc())
            .or().like("`jcnr`", mjyJcgj.getJcmc()));
        }
        queryWrapper.orderByDesc("id");
        return this.list(queryWrapper);
    }

    /**
     * 新增稽查轨迹
     * @param mjyId 麻精药id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  void saveJcgj(Long  mjyId, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark){
        MjyJcgj mjyJcgj = new MjyJcgj();
        mjyJcgj.setMjyId(mjyId);
        mjyJcgj.setJcgjlx(jcgjlx);
        mjyJcgj.setJcmc(jcmc);
        mjyJcgj.setJcmcEn(MjyJcnrUtil.getEn(jcmc));
        mjyJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            mjyJcgj.setJcnr(JctUtil.formatStr(jcnr));
            mjyJcgj.setJcnrEn(MjyJcnrUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null){
            mjyJcgj.setQmrId(qmr.getUserId());
            mjyJcgj.setQmrMc(qmr.getNickName());
            mjyJcgj.setQmrMcEn(qmr.getUserName());
        }
        mjyJcgj.setRemark(remark);
        this.save(mjyJcgj);
    }

    /**
     * 新增稽查轨迹
     * @param mjyId 麻精药id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  MjyJcgj getJcgj(Long  mjyId, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark){
        MjyJcgj mjyJcgj = new MjyJcgj();
        mjyJcgj.setMjyId(mjyId);
        mjyJcgj.setJcgjlx(jcgjlx);
        mjyJcgj.setJcmc(jcmc);
        mjyJcgj.setJcmcEn(MjyJcnrUtil.getEn(jcmc));
        mjyJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            mjyJcgj.setJcnr(JctUtil.formatStr(jcnr));
            mjyJcgj.setJcnrEn(MjyJcnrUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null) {
            mjyJcgj.setQmrId(qmr.getUserId());
            mjyJcgj.setQmrMc(qmr.getNickName());
            mjyJcgj.setQmrMcEn(qmr.getUserName());
        }
        mjyJcgj.setRemark(remark);
        return  mjyJcgj;
    }

    /**
     * 新增稽查轨迹
     * @param mjyId 麻精药id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param jcnrEn 稽查内容英文
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  MjyJcgj getJcgj(Long  mjyId, Integer jcgjlx, String jcmc, Integer jcmcys, String jcnr,String jcnrEn, SysUser qmr, String remark){
        MjyJcgj mjyJcgj = new MjyJcgj();
        mjyJcgj.setMjyId(mjyId);
        mjyJcgj.setJcgjlx(jcgjlx);
        mjyJcgj.setJcmc(jcmc);
        mjyJcgj.setJcmcEn(MjyJcnrUtil.getEn(jcmc));
        mjyJcgj.setJcmcys(jcmcys);
        mjyJcgj.setJcnr(jcnr);
        mjyJcgj.setJcnrEn(jcnrEn);
        if(qmr!=null) {
            mjyJcgj.setQmrId(qmr.getUserId());
            mjyJcgj.setQmrMc(qmr.getNickName());
            mjyJcgj.setQmrMcEn(qmr.getUserName());
        }
        mjyJcgj.setRemark(remark);
        return  mjyJcgj;
    }

}
